%% Controller Specifications
% 4% Settling time (s)
ts = 1.5; 
c_ts = 0.04;% 
% Percentage overshoot (%)
PO = 2.5;
% Damping ratio from overshoot specification.
zeta = -log(PO/100) * sqrt( 1 / ( ( log(PO/100) )^2 + pi^2 ) );    
% Natural frequency from specifications (rad/s)
wn = -log( c_ts * sqrt(1-zeta^2) ) / (zeta * ts);
% 
%% Modeling
% x_ddot = 3/5*g*sin(alpha)
g = 9.81;
Kbb = 3/5*g; 
P = tf( [Kbb], [1 0 0]);
%
%% Control Design
% Proportional Gain (rad/m)
Kp = wn^2 / Kbb;
% Derivative Gain (rad-s/m)
Kd = 2*zeta*wn / Kbb;
disp(['Kp = ', num2str(Kp)]);
disp(['Kd = ', num2str(Kd)]);
% PD control
C = pid2(Kp,0,Kd,0,1,0);
% 
%% Simulatiom
% loop transfer function
L = series(C,P);
% feedback: construct closed-loop proportional-rate feedback system (PV)
% G = feedback(L,1);
P.InputName='u';
P.OutputName = 'y';
C.Inputname = {'r','y'};
C.OutputName = 'u';
G = connect(P,C,'r','y');
% transfer function of closed-loop system
% Gtf = tf(G);
% step(G);
% step_info = stepinfo(G);
