% test_your_model.m
% HG - 18/11/2020

load data_step_Beam;
close all

% Modify the default value for the first-order model parameters below
K=11;
T=0.25;

t=data0(1,:)';
y0=data0(2,:)';
initial_speed=y0(3,1);
y=y0-initial_speed;   % Removal of the possibly non-zero initial angular speed 
u=data0(3,:)';        % for the simulation
Ts=t(2)-t(1);
data=iddata(y,u,Ts);

M=tf(K,[T 1]);

yhat=lsim(M,u,t);

FIT = 100 * (1-norm(y-yhat)/norm(y-mean(y)));

figure
plot(t,y+initial_speed,t,yhat+initial_speed,'linewidth',2)
xlabel('Time (s)')
legend('Measured angular speed','Simulated angular speed','location','Northwest')
title(['Fit between the model and measured responses: ',num2str(FIT,'% 10.1f'),' %'])
set(gca,'FontSize',12,'FontName','helvetica');
grid
shg


